/*********************************
 options.c             1999/4/22
                        ãϺ
  morimoto@sse.ecei.tohoku.ac.jp
**********************************/
#include "flexdownload.h"

int initialize_defaults()
{
  status.verbose = DEFAULT_VERBOSE;
  strcpy(status.input_file_name, "input_file_name");
  status.base_address = DEFAULT_BASE_ADDRESS;
  status.dummy_address = DEFAULT_DUMMY_ADDRESS;
  status.wait_counts = DEFAULT_WAIT_COUNTS;
  status.progress_bar = DEFAULT_PROGRESS_BAR;
  status.mode[0] = DEFAULT_FILEREAD_MODE;
  status.mode[2] = DEFAULT_DOWNLOAD_MODE;
  status.mode[3] = DEFAULT_RESERVED_MODE;
  return (0);
}

int options_parse(int argc, char **argv)
{
  strcpy(status.program_name, argv[0]);
  initialize_defaults();
  while ((argc > 1) && (argv[1][0] == '-')) {
    switch (argv[1][1]){
    case 'v': /* verbose(ܺɽ)⡼ */
      status.verbose = 1;
      break;
    case 'p': /* ѥݡȤΥ١ɥ쥹 */
	argv++;
	argc--;
	switch (argv[1][0]){
	case '0':
	  status.base_address = 0x378;
	  break;
	case '1':
	  status.base_address = 0x278;
	  break;
	case '2':
	  status.base_address = 0x3BC;
	  break;
	default:
	  fprintf(stderr,"Bad option %s\n", argv[1]);
	  usage();
	  break;
	}
	break;
    case 'd': /* ĴѥߡݡȤΥ١ɥ쥹 */
	argv++;
	argc--;
	switch (argv[1][0]){
	case '0':
	  status.base_address = 0x80;
	  break;
	default:
	  fprintf(stderr,"Bad option %s\n", argv[1]);
	  usage();
	  break;
	}
	break;
    case 'w': /* åWait */
	argv++;
	argc--;
	status.wait_counts = atoi(&argv[1][0]);
	break;
    case 'b': /* ΥСɽ */
      status.progress_bar = 1;
      break;
    case 'm': /* ⡼ */
      switch (argv[1][2]){
      case 'f': /* ɻΥǡɤ߹ˡ */
	argv++;
	argc--;
	status.mode[0] = atoi(&argv[1][0]);
	break;
      case 'd': /* I/OݡȤؤΥˡ */
	argv++;
	argc--;
	status.mode[1] = atoi(&argv[1][0]);
	break;
      default:
	fprintf(stderr,"Bad option %s\n", argv[1]);
	usage();
      }
      break;
    case 'h': /* إɽ */
      help_message();
      break;
    default:
      fprintf(stderr,"Bad option %s\n", argv[1]);
      usage();
    }
    argv++;
    argc--;
  }
  if (argc == 2) { /* ϥե̾ */
    strcpy(status.input_file_name, argv[1]);
  }else{
    usage();
  }

  if (status.verbose == 1){
    print_param();
  }

  return (0);
}
